﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using CreateWordSample.Models;
using Syncfusion.DocIO.DLS;
using System.IO;
using Syncfusion.DocIO;
using Syncfusion.Drawing;
using Syncfusion.OfficeChart;
using System.Collections;
using Syncfusion.Drawing;
using System.Dynamic;

namespace CreateWordSample.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }
      
        public ActionResult MailMergeWithDataTable()
        {
            FileStream fileStreamPath = new FileStream(@"Data/Template.docx", FileMode.Open, FileAccess.Read, FileShare.ReadWrite);

            //Loads an existing Word document
            using (WordDocument document = new WordDocument(fileStreamPath, FormatType.Docx))
           {
                TextSelection textSelection = document.Find("MyTable", false,false);
                //Gets text range from text selection
                WTextRange textRange = textSelection.GetAsOneRange();
                //Gets the owner paragraph from the text
                WParagraph paragraph = textRange.OwnerParagraph;
                //Gets the table using NextSibling API
                WTable table = paragraph.NextSibling as WTable;
                paragraph = table.NextSibling as WParagraph;
                
                #region Save
                MemoryStream stream = new MemoryStream();

                ////Saves the Word document to  MemoryStream
                document.Save(stream, FormatType.Docx);
                document.Close();
                
                stream.Position = 0;

                //Download Word document in the browser
                return File(stream, "application/msword", "Result.docx");
#endregion
            }

        }
        
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
